(ns lineup.events
  (:require
   [lineup.db :as db]
   [re-frame.core :as re-frame]))

(re-frame/reg-event-db
 ::initialize-db
 (fn [_ _]
   db/default-db))

(re-frame/reg-event-db
 ::toggle-mode
 (fn [db [_ new-mode]]
   (assoc db :mode new-mode)))

(re-frame/reg-event-db
 ::toggle-task-complete
 (fn [db [_ which]]
   (update-in
    db
    [:schedule :tasks]
    (partial map-indexed #(if (= %1 which)
                            (update %2 :complete? not)
                            %2)))))
